DO CASE
  CASE upper(pb)="EDIT"
    ** get a copy of the record
    SCATTER MEMVAR MEMO 
    ** give the user access to the the GETs
    SHOW GETS ENABLED
    ** disable any unique key
    SHOW GET m.cu_custid DISABLED
    ** put the cursor in the company field
    _curobj=OBJNUM(m.cu_company)
    ** go back to editing the record
    RETURN .T.
  CASE upper(pb)="SAVE"
    ** save changes to record
    IF !RLOCK()
      ** can't save this user's changes!
      DO l2msg WITH "Sorry. Someone else is changing this record."+;
      " Your changes will NOT BE SAVED!","Ok"
    ELSE
      ** since a record lock insures a current copy 
      ** of the record, compare the new version of 
      ** the signature field with the copy created by
      ** the original SCATTER MEMVAR MEMO
      IF m.signature<>signature
        ** the signature field does not match
        ** the signature memory variable, so
        ** this record was changed by another user 
        ** while this user
        ** was editing.
        UNLOCK
        DO l2msg with "Sorry. Either you started out with an old copy"+;
          " of this record, or someone changed it on you while you"+;
          " were editing. Your changes WILL NOT BE SAVED!","Ok"
      ELSE
        ** Hurray! He's been working with the current
        ** record, and nobody
        ** else changed it while he was editing!
        ** increment the signature variable
        IF VAL(REPLICATE("9",FSIZE('signature'))) = 
          m.signature
          ** signature is "full", roll over to 1
          m.signature=1
        ELSE
          m.signature=m.signature+1
        ENDIF
        GATHER MEMVAR MEMO  && save memvars to current record
        UNLOCK
      ENDIF was working with an old copy 
    ENDIF not able to lock
    ** kill the other gets
    SHOW GETS DISABLED
    ** give them a push button to work with
    SHOW GET pb ENABLED
  CASE upper(pb)="ABORT"
    ** Reset the memory variables
    SCATTER MEMVAR MEMO
    ** kill the other gets
    SHOW GETS DISABLED
    ** give them a push button to work with
    SHOW GET pb ENABLED
ENDCASE
RETURN .T.    


